#pragma once
#include <windows.h>
#include <dxerr9.h>
#include <d3dx9math.h>
#include <d3d9.h>
#include <d3dx9.h>
#define RELEASE(x) 	if(x){x->Release();x=NULL;}


class CDXDevice{
protected:
	LPDIRECT3D9 m_lpD3D;
	LPDIRECT3DDEVICE9 m_lpD3DDevice;

	D3DPRESENT_PARAMETERS m_D3DParam;
	HWND m_hWnd;
public:
	CDXDevice():m_lpD3D(NULL),m_lpD3DDevice(NULL),m_hWnd(NULL){}
	virtual ~CDXDevice();					//fXgN^
	bool IsOK()const{return (NULL!=m_lpD3DDevice);}	//foCXłĂ邩ǂ
	bool IsReady()const{return m_lpD3DDevice && D3D_OK==m_lpD3DDevice->TestCooperativeLevel();}

	//DirectXIuWFNgуfoCX쐬
	bool Create(HWND hWnd,int Width,int Height);
	void Destroy();			//foCXj
	inline virtual LPDIRECT3DDEVICE9 Handle(){return m_lpD3DDevice;}	//foCXnh擾

	bool Clear(DWORD Flags=D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR Color=D3DCOLOR_XRGB(0,0,0),float Z=1.0f);//obt@
	bool Reset();
	bool ResetDeviceIfLost();

};

